=== manual/requirements.txt ===
sphinx==5.3.0
seqansphinx>=0.4.0
sphinx_rtd_theme
sphinxcontrib-bibtex
nose2
jinja2
