=== debian/changelog ===
seqan2 (2.5.0~rc2+dfsg-2) experimental; urgency=medium

  * Can't make docs or the manual yet, "seqansphinx" is not yet packaged

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 16 Aug 2024 14:19:19 +0200

seqan2 (2.5.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream version
  * Resume building razers{,3} everywhere.
  * d/rules: According to upstream, solution_online_search_finder.cpp
    works again, so stop deleting that test

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 16 Aug 2024 13:07:37 +0200

seqan2 (2.5.0~rc1+dfsg-1~0exp1) experimental; urgency=medium

  * debian/libseqan2-dev.docs: README.rst→README.md
  * debian/rules: restore "reproducible=-fixfilepath"

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 14 Aug 2024 17:36:14 +0200

seqan2 (2.5.0~rc1+dfsg-1~0exp0) experimental; urgency=medium

  * d/watch: updated to catch release candidates.
  * New upstream version
  * Rely on pre-initialized dpkg-architecture variables.
  * d/patches: many patches upstreamed and removed.
  * d/rules: remove max build limit for amd64 from 2018.
  * Skip building razers & razers3 on all architectures.
  * d/rules: configure with -DALIGN_SIMD_TEST=FALSE as per upstream, to
    avoid compiling a 256+ level template in debug mode which takes up too
    much memory.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 03 Aug 2024 13:24:50 +0200
